unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Controls, Forms, StdCtrls, ExtCtrls, Dialogs, IEInstVer;

type
  TForm1 = class(TForm)
    GroupBox1: TGroupBox;
    RadioGroup1: TRadioGroup;
    ListBox1: TListBox;
    Panel1: TPanel;
    Button1: TButton;
    Button2: TButton;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    Edit1: TEdit;
    IEInstVer1: TIEInstVer;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure IEInstVer1IE1Installed(Sender: TObject);
    procedure IEInstVer1IE2Installed(Sender: TObject);
    procedure IEInstVer1IE3Installed(Sender: TObject);
    procedure IEInstVer1IE4Installed(Sender: TObject);
    procedure IEInstVer1IE5Installed(Sender: TObject);
    procedure IEInstVer1IE5_5Installed(Sender: TObject);
    procedure IEInstVer1IE6Installed(Sender: TObject);
    procedure IEInstVer1IEInstalled(Sender: TObject);
    procedure IEInstVer1NotIEInstalled(Sender: TObject);
    procedure CheckBox3Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);

  private
    procedure GetValues;

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.GetValues;
begin
  ListBox1.Clear;
  CheckBox1.Checked := False;
  CheckBox2.Checked := False;
  CheckBox2.Enabled := False;

  with IEInstVer1 do
  begin
    with ListBox1.Items do
    begin
      Add('========================================================');
      Add('Version Properties:');
      Add('========================================================');
      Add('');
      Add('VersionNumberRegistry: string;');
      Add(VersionNumberRegistry);
      Add('');
      Add('BuildNumberRegistry: string;');
      Add(BuildNumberRegistry);
      Add('');
      Add('CustomizedVersion: string;');
      Add(CustomizedVersion);
      Add('');
      Add('UpdateVersion: string;');
      Add(UpdateVersion);
      Add('');
      Add('VersionNumberShDocVwDll: string;');
      Add(VersionNumberShDocVwDll);
      Add('');
      Add('VersionDescription: string;');
      Add(VersionDescription);
      Add('');
      Add('EncryptionStrength: string;');
      Add(EncryptionStrength);
      Add('');

      Add('========================================================');
      Add('Previous Version Properties:');
      Add('========================================================');
      Add('');
      Add('PreviousVersionNumber: string;');
      Add(PreviousVersionNumber);
      Add('');
      Add('PreviousVersionDescription: string;');
      Add(PreviousVersionDescription);
      Add('');

      Add('========================================================');
      Add('ShellFolders Properties:');
      Add('========================================================');
      Add('');
      Add('CookiesFolderPath: string;');
      Add(CookiesFolderPath);
      Add('');
      Add('FavoritesFolderPath: string;');
      Add(FavoritesFolderPath);
      Add('');
      Add('HistoryFolderPath: string;');
      Add(HistoryFolderPath);
      Add('');
      Add('InternetCacheFolderPath: string;');
      Add(InternetCacheFolderPath);
      Add('');

      Add('========================================================');
      Add('SpecialFolders Properties:');
      Add('========================================================');
      Add('');
      Add('DownloadFolderPath: string;');
      Add(DownloadFolderPath);
      Add('');
      Add('LinksFolderPath: string;');
      Add(LinksFolderPath);
      Add('');
      Add('SaveFolderPath: string;');
      Add(SaveFolderPath);
      Add('');

      Add('========================================================');
      Add('URLs Properties:');
      Add('========================================================');
      Add('');
      Add('LocalPage: string;');
      Add(LocalPage);
      Add('');
      Add('SearchPage: string;');
      Add(SearchPage);
      Add('');
      Add('StartPage: string;');
      Add(StartPage);
      Add('');

      Add('========================================================');
      Add('Misc Properties:');
      Add('========================================================');
      Add('');
      Add('UserAgent: string;');
      Add(UserAgent);
      Add('');
      Add('WindowTitle: string;');
      Add(WindowTitle);
      Add('')
    end
  end
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  GetValues;
  CheckBox3.Checked := IEInstVer1.TriggerEventsOnUpdate;
  IEInstVer1.UpdateValues
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  Edit1.SetFocus
end;

procedure TForm1.IEInstVer1IE1Installed(Sender: TObject);
begin
  RadioGroup1.ItemIndex := 0
end;

procedure TForm1.IEInstVer1IE2Installed(Sender: TObject);
begin
  RadioGroup1.ItemIndex := 1
end;

procedure TForm1.IEInstVer1IE3Installed(Sender: TObject);
begin
  RadioGroup1.ItemIndex := 2
end;

procedure TForm1.IEInstVer1IE4Installed(Sender: TObject);
begin
  RadioGroup1.ItemIndex := 3
end;

procedure TForm1.IEInstVer1IE5Installed(Sender: TObject);
begin
  RadioGroup1.ItemIndex := 4
end;

procedure TForm1.IEInstVer1IE5_5Installed(Sender: TObject);
begin
  CheckBox2.Enabled := True;
  CheckBox2.Checked := True
end;

procedure TForm1.IEInstVer1IE6Installed(Sender: TObject);
begin
  RadioGroup1.ItemIndex := 6
end;

procedure TForm1.IEInstVer1IEInstalled(Sender: TObject);
begin
  CheckBox1.Checked := True;
  RadioGroup1.Enabled := True
end;

procedure TForm1.IEInstVer1NotIEInstalled(Sender: TObject);
begin
  RadioGroup1.Enabled := False;
  with ListBox1.Items do
  begin
    Add(''); Add(''); Add(''); Add(''); Add(''); Add(''); Add('');
    Add('========================================================');
    Add('Microsoft Internet Explorer is not installed!');
    Add('========================================================')
  end
end;

procedure TForm1.CheckBox3Click(Sender: TObject);
begin
  IEInstVer1.TriggerEventsOnUpdate := CheckBox3.Checked
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  RadioGroup1.ItemIndex := -1;
  IEInstVer1.UpdateValues;
  GetValues;
  IEInstVer1.UpdateValues
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  IEInstVer1.TriggerEvents
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Application.MessageBox(pchar(IEInstVer1.About), 'Property: About: string;', MB_OK + MB_ICONASTERISK + MB_APPLMODAL)
end;

end.
