unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  EasyFileSearch, FileSearch, StdCtrls, ComCtrls, Buttons, ExtCtrls,
  ImgList,shlobj;

type
  TForm1 = class(TForm)
    EasyFileSearch1: TEasyFileSearch;
    GroupBox1: TGroupBox;
    Edit1: TEdit;
    Label1: TLabel;
    Edit2: TEdit;
    Label2: TLabel;
    GroupBox2: TGroupBox;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    CheckBox5: TCheckBox;
    CheckBox6: TCheckBox;
    CheckBox7: TCheckBox;
    BitBtn1: TBitBtn;
    GroupBox3: TGroupBox;
    ListView1: TListView;
    StatusBar1: TStatusBar;
    GroupBox4: TGroupBox;
    Label3: TLabel;
    Panel1: TPanel;
    Label4: TLabel;
    Panel2: TPanel;
    Label5: TLabel;
    Panel3: TPanel;
    ImageList1: TImageList;
    GroupBox5: TGroupBox;
    CheckBox8: TCheckBox;
    CheckBox9: TCheckBox;
    ComboBox1: TComboBox;
    Label6: TLabel;
    Label7: TLabel;
    Edit3: TEdit;
    Label8: TLabel;
    ComboBox2: TComboBox;
    Label9: TLabel;
    DateTimePicker1: TDateTimePicker;
    Label10: TLabel;
    DateTimePicker2: TDateTimePicker;
    Label11: TLabel;
    ComboBox3: TComboBox;
    Label12: TLabel;
    Panel4: TPanel;
    GroupBox6: TGroupBox;
    ListBox1: TListBox;
    Button1: TButton;
    Edit4: TEdit;
    Button2: TButton;
    BitBtn2: TBitBtn;
    Button3: TButton;
    ListBox2: TListBox;
    Button4: TButton;
    GroupBox7: TGroupBox;
    CheckBox10: TCheckBox;
    Panel5: TPanel;
    Label13: TLabel;
    Label14: TLabel;
    procedure FormActivate(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure EasyFileSearch1ChangeFolder(NewPath: String);
    procedure EasyFileSearch1Statistics(Stats: TStatistics);
    procedure CheckBox9Click(Sender: TObject);
    procedure CheckBox8Click(Sender: TObject);
    procedure ComboBox2Change(Sender: TObject);
    procedure EasyFileSearch1FileFound(FileFound: TFileInformations);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    function EasyFileSearch1AcceptFile(
      FileFound: TFileInformations): Boolean;
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormActivate(Sender: TObject);
begin
  { Write Version in the title }
  Caption := EasyFileSearch1.Version + ' - Demo application';
  ComboBox1.ItemIndex := 0;
  ComboBox2.ItemIndex := 3;
  ComboBox3.ItemIndex := 0;
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
var
  Ok : Boolean;
begin
  Ok := True;

  Edit1.Text := Trim(Edit1.Text);
  if ListBox2.Items.Count=0 then
  begin
    MessageBox(Handle, 'You must enter a filename !', 'ERROR', MB_OK);
    Ok := False;
    Edit1.SetFocus;
  end;

  Edit2.Text := Trim(Edit2.Text);
  if Length(Edit2.Text)=0 then
  begin
    MessageBox(Handle, 'You must enter a pathname !', 'ERROR', MB_OK);
    Ok := False;
    Edit2.SetFocus;
  end;

  if Ok=True then
  begin
    { Initialise filters }
    EasyFileSearch1.RootPath := Edit2.Text;
    EasyFileSearch1.FileNames.Clear;
    EasyFileSearch1.FileNames.Assign(ListBox2.Items);

    { Initialize search criteria }
    with EasyFileSearch1 do
    begin
      SearchOptions := [];
      if CheckBox1.Checked=True then SearchOptions := SearchOptions + [okIncludeSubfolder   ];
      if CheckBox2.Checked=True then SearchOptions := SearchOptions + [okLookForReadOnlyFile];
      if CheckBox3.Checked=True then SearchOptions := SearchOptions + [okLookForHiddenFile  ];
      if CheckBox4.Checked=True then SearchOptions := SearchOptions + [okLookForSystemFile  ];
      if CheckBox5.Checked=True then SearchOptions := SearchOptions + [okLookForDirectory   ];
      if CheckBox6.Checked=True then SearchOptions := SearchOptions + [okLookForArchiveFile ];
      if CheckBox7.Checked=True then SearchOptions := SearchOptions + [okLookForAnyFile     ];
    end;

    { Initialize Filter }
    EasyFileSearch1.FilterKind := [];
    { Size }
    if CheckBox9.Checked=True then EasyFileSearch1.FilterKind := EasyFileSearch1.FilterKind + [fkFilterOnSize];
    case ComboBox1.ItemIndex of
      0: EasyFileSearch1.SizeFilterKind := sfkSmallerOrEqualTo;
      1: EasyFileSearch1.SizeFilterKind := sfkBiggerOrEqualTo ;
    end;
    EasyFileSearch1.SizeFilterSize := StrToInt(Edit3.Text);
    { Date }
    if CheckBox8.Checked=True then EasyFileSearch1.FilterKind := EasyFileSearch1.FilterKind + [fkFilterOnDate];
    case ComboBox2.ItemIndex of
      0: EasyFileSearch1.DateFilterKind := dfkBetween;
      1: EasyFileSearch1.DateFilterKind := dfkAfter  ;
      2: EasyFileSearch1.DateFilterKind := dfkBefore ;
      3: EasyFileSearch1.DateFilterKind := dfkSame   ;
    end;
    EasyFileSearch1.DateFilterFirstDate  := DateTimePicker1.Date;
    EasyFileSearch1.DateFilterSecondDate := DateTimePicker2.Date;
    case ComboBox3.ItemIndex of
      0: EasyFileSearch1.DateFilterFileAccess := dfakAnyFiles;
      1: EasyFileSearch1.DateFilterFileAccess := dfakCreatedFiles;
      2: EasyFileSearch1.DateFilterFileAccess := dfakModifiedFiles;
      3: EasyFileSearch1.DateFilterFileAccess := dfakOpenedFiles;
    end;

    { Excluded files }
    EasyFileSearch1.ExcludedFiles.Clear;
    EasyFileSearch1.ExcludedFiles.Assign(ListBox1.Items);

    { Start Search }
    ListView1.Items.BeginUpdate;
    ListView1.Items.Clear;
    if EasyFileSearch1.Search=False then MessageBox(Handle, 'Error during the search operation !', 'ERROR', 0);
    ListView1.Items.EndUpdate;
  end;
end;


procedure TForm1.EasyFileSearch1ChangeFolder(NewPath: String);
begin
  { Show which is the current folder }
  StatusBar1.SimpleText := NewPath;
end;

procedure TForm1.EasyFileSearch1Statistics(Stats: TStatistics);
begin
  Panel1.Caption := IntToStr(Stats.NbFilesFound);
  Panel2.Caption := IntToStr(Stats.NbPathFound );
  Panel3.Caption := IntToStr(Stats.TimeNeeded    );
  Panel4.Caption := IntToStr(Stats.NbFilesFound+Stats.NbPathFound);
  Panel5.Caption := IntToStr(Stats.FoundInNbPath);
end;

procedure TForm1.CheckBox9Click(Sender: TObject);
begin
  Label6.Enabled    := CheckBox9.Checked;
  ComboBox1.Enabled := CheckBox9.Checked;
  Label7.Enabled    := CheckBox9.Checked;
  Edit3.Enabled     := CheckBox9.Checked;
end;

procedure TForm1.CheckBox8Click(Sender: TObject);
begin
  LAbel11.Enabled    := CheckBox8.Checked;
  ComboBox3.Enabled    := CheckBox8.Checked;
  Label8.Enabled    := CheckBox8.Checked;
  ComboBox2.Enabled := CheckBox8.Checked;
  Label9.Enabled    := CheckBox8.Checked;
  DateTimePicker1.Enabled := CheckBox8.Checked;

  if ComboBox2.ItemIndex=0 then Label10.Enabled := True else Label10.Enabled := False;
  DateTimePicker2.Enabled := Label10.Enabled;

  
end;

procedure TForm1.ComboBox2Change(Sender: TObject);
begin
  CheckBox8Click(nil);
end;

procedure TForm1.EasyFileSearch1FileFound(FileFound: TFileInformations);
var
  NewItem : TListItem;
  Time    : String;
begin
  { Add the file found }
  NewItem := ListView1.Items.Add;
  with NewItem do
  begin
    Caption := FileFound.Name;
    SubItems.Add(FileFound.Path);
    Time := IntToStr(FileFound.Time.CreationTime.wDay)+'/';
    Time := Time+IntToStr(FileFound.Time.CreationTime.wMonth)+'/';
    Time := Time+IntToStr(FileFound.Time.CreationTime.wYear);
    SubItems.Add(Time);
    SubItems.Add(IntToStr(FileFound.Size));

    { Folder or File }
    if (FileFound.Attributes and faDirectory)<>0 then ImageIndex := 0 else ImageIndex := 1;
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  ListBox1.Items.Add(Edit4.Text);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  ListBox1.Items.Clear;
end;

procedure TForm1.BitBtn2Click(Sender: TObject);
var
  Bro        : BROWSEINFO;
  ItemID     : PITEMIDLIST;
  Result     : array[1..MAX_PATH] of Char;
begin
  Bro.hwndOwner      := Handle  ; // Fenetre appelante
  Bro.pidlRoot       := nil     ; // Repertoire de depart
  Bro.pszDisplayName := @Result ; // Resultat de la selection
  Bro.lpszTitle      := 'Slectionnez un rpertoire'; // Titre de la fenetre
  Bro.ulFlags        := 0        ;
  Bro.lpfn           := nil      ; // Fonction 'callback' appele a chaque evenements
  Bro.lParam         := 0        ; // Parametre passe a la fonction 'callback'
  Bro.iImage         := 0        ; // Index de l'image
  { Ouvre la fenetre de parcour }
  ItemID := SHBrowseForFolder(Bro);

  { Si une selection a ete faite }
  if ItemID<>nil then
  begin
    if SHGetPathFromIDList(ItemID, @Result)=True then Edit2.Text := Result;
  end;

end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  ListBox2.Items.Add(Edit1.Text);
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  ListBox2.Items.Clear;
end;

function TForm1.EasyFileSearch1AcceptFile(FileFound: TFileInformations): Boolean;
begin
  if CheckBox10.Checked=True then
  begin
    { Only short filename less or egal to 8 characters }
    if Length(ExtractFileName(FileFound.Name))<=8 then Result := True else Result := False;
  end
  else Result := True; { Accept all file }
end;

end.
