unit EncryptIt;

interface
USES
  Classes, Sysutils, forms, comctrls, StdCtrls;

function Encrypt(const S: String; Key,C1,C2: Word): String;
function Decrypt(const S: String; Key,C1,C2: Word): String;
procedure EncryptFile(INFName, OutFName : String; Key,C1,C2 : Word; ShowProgress: boolean);
procedure DecryptFile(INFName, OutFName : String; Key,C1,C2 : Word; ShowProgress: boolean);
procedure HDEncryptFile(INFName, OutFName, TempPath : String; Key,C1,C2 : Word);
procedure HDDecryptFile(INFName, OutFName : String; Key,C1,C2 : Word);

implementation

function Encrypt(const S: String; Key,C1,C2: Word): String;
var
   I: Integer;
begin
  Result := S;
  for I := 1 to Length(S) do
      begin
           Result[I] := char(byte(S[I]) xor (Key shr 8));
           Key := (byte(Result[I]) + Key) * C1 + C2;
      end;
  end;

function Decrypt(const S: String; Key,C1,C2: Word): String;
var
   I: Integer;
begin
  Result := S;
  for I := 1 to Length(S) do
      begin
           Result[I] := char(byte(S[I]) xor (Key shr 8));
           Key := (byte(S[I]) + Key) * C1 + C2;
      end;
  end;


procedure EncryptFile(INFName, OutFName : String; Key,C1,C2 : Word; ShowProgress: boolean);
VAR
   MS, SS : TMemoryStream;
   X : Integer;
   C : Byte;
   adv: TForm;
   lab: TProgressBar;
   cur, tot: int64;
begin
if (key=1) and (c1=2) and (c2=3) then
        begin
        key:=11;
        c1:=21;
        c2:=32;
        end;
MS := TMemoryStream.Create;
SS := TMemoryStream.Create;
    TRY
       MS.LoadFromFile(INFName);
       MS.Position := 0;
       tot:=ms.size;
       if showprogress then
                begin
                adv:=TForm.Create(nil);
                adv.Name:='AdvForm';
                Adv.Position:=poScreenCenter;
                adv.BorderStyle:=bsDialog;
                adv.FormStyle:=fsStayOnTop;
                adv.Height:=120;
                adv.Width:=320;
                adv.caption:=Extractfilename(infname);
                adv.Visible:=true;
                adv.BorderIcons:=[];
                lab:=TProgressBar.Create(nil);
                lab.Parent:=adv;
                lab.Top:=(adv.Height div 2) - (lab.Height div 2)-12;
                lab.Left:=12;
                lab.Width:=adv.Width-36;
                lab.Visible:=true;
                lab.Max:=100;
                lab.min:=0;
                lab.Position:=0;
                adv.show;
                end;
       FOR X := 0 TO MS.Size - 1 DO
             begin
                  MS.Read(C, 1);
                  C := (C xor (Key shr 8));
                  Key := (C + Key) * C1 + C2;
                  SS.Write(C,1);
                  if showprogress then
                        begin
                        cur:=x;
                        lab.position:=Longint(Trunc( (cur * 100) / Tot ));
                        adv.caption:=Extractfilename(infname)+' - '+inttostr(lab.Position)+'%';
                        application.processmessages;
                        end;
             end;
       SS.SaveToFile(OutFName);
    FINALLY
           SS.Free;
           MS.Free;
           if showprogress then adv.free;
    end;
end;

procedure DecryptFile(INFName, OutFName : String; Key,C1,C2 : Word; ShowProgress: boolean);
VAR
   MS, SS : TMemoryStream;
   X : Integer;
   C, O : Byte;
   adv: TForm;
   lab: TProgressBar;
   cur, tot: integer;
begin
//showmessage(inttostr(key));
//showmessage(inttostr(c1));
//showmessage(inttostr(c2));
//if c1=2 then c1:=3;
if (key=1) and (c1=2) and (c2=3) then
        begin
        key:=11;
        c1:=21;
        c2:=32;
        end;
MS := TMemoryStream.Create;
SS := TMemoryStream.Create;
    TRY
       MS.LoadFromFile(INFName);
       MS.Position := 0;
       tot:=ms.size;
       if showprogress then
                begin
                adv:=TForm.Create(nil);
                adv.Name:='AdvForm';
                Adv.Position:=poScreenCenter;
                adv.BorderStyle:=bsDialog;
                adv.FormStyle:=fsStayOnTop;
                adv.Height:=120;
                adv.Width:=320;
                adv.caption:=Extractfilename(infname);
                adv.Visible:=true;
                adv.BorderIcons:=[];
                lab:=TProgressBar.Create(nil);
                lab.Parent:=adv;
                lab.Top:=(adv.Height div 2) - (lab.Height div 2)-12;
                lab.Left:=12;
                lab.Width:=adv.Width-36;
                lab.Visible:=true;
                lab.Max:=100;
                lab.min:=0;
                lab.Position:=0;
                adv.show;
                end;
       FOR X := 0 TO MS.Size - 1 DO
             begin
                  MS.Read(C, 1);
                  O := C;
                  C := (C xor (Key shr 8));
                  Key := (O + Key) * C1 + C2;
                  SS.Write(C,1);
                  if showprogress then
                        begin
                        cur:=x;
                        lab.position:=Longint(Trunc( (cur * 100) / Tot ));
                        adv.caption:=Extractfilename(infname)+' - '+inttostr(lab.Position)+'%';
                        end;
                  application.processmessages;
             end;
       SS.SaveToFile(OutFName);
    FINALLY
           SS.Free;
           MS.Free;
           if showprogress then adv.free;
    end;
end;

procedure HDEncryptFile(INFName, OutFName, TempPath : String; Key,C1,C2 : Word);
VAR
   MS, SS : TFileStream;
   X : Integer;
   C : Byte;
   mm: string;
   adv: TForm;
   lab: TProgressBar;
   cur, tot: integer;
begin
if (key=1) and (c1=2) and (c2=3) then
        begin
        key:=11;
        c1:=21;
        c2:=32;
        end;
mm:=temppath+extractfilename(outfname);
MS := TFileStream.Create(infname,fmOpenRead);
SS := TFileStream.Create(mm,fmCreate);
    TRY
       MS.Position := 0;
       tot:=ms.size;
       adv:=TForm.Create(nil);
       adv.Name:='AdvForm';
       Adv.Position:=poScreenCenter;
       adv.BorderStyle:=bsDialog;
       adv.FormStyle:=fsStayOnTop;
       adv.Height:=120;
       adv.Width:=320;
       adv.caption:='Zip -> CZip';
       adv.Visible:=true;
       lab:=TProgressBar.Create(nil);
       lab.Parent:=adv;
       lab.Top:=adv.Height div 2-20;
       lab.Left:=12;
       lab.Width:=adv.Width-30;
       lab.Visible:=true;
       lab.Max:=100;
       lab.min:=0;
       lab.Position:=0;
       FOR X := 0 TO MS.Size - 1 DO
             begin
                  MS.Read(C, 1);
                  C := (C xor (Key shr 8));
                  Key := (C + Key) * C1 + C2;
                  SS.Write(C,1);
                  cur:=SS.Size;
                  lab.position:=Longint(Trunc( (cur * 100) / Tot ));
                  Application.ProcessMessages;
                  adv.caption:=extractfilename(infname)+' - '+inttostr(lab.position)+'%';
                  Application.ProcessMessages;
             end;
    FINALLY
           SS.Free;
           MS.Free;
           adv.free;
//           dkyMoveFiles(temppath,extractfilepath(infname),extractfilename(outfname),true,false);
    end;
end;

procedure HDDecryptFile(INFName, OutFName: String; Key,C1,C2 : Word);
VAR
   MS : TFileStream;
   SS : TFileStream;
   X : Integer;
   C, O : Byte;
   mm: string;
   adv: TForm;
   lab: TProgressBar;
   cur, tot: integer;

begin
if (key=1) and (c1=2) and (c2=3) then
        begin
        key:=11;
        c1:=21;
        c2:=32;
        end;
MS := TFileStream.Create(infname,fmOpenRead);
SS := TFileStream.Create(outfname,fmCreate);
tot:=ms.size;
    TRY
       MS.Position := 0;
       adv:=TForm.Create(nil);
       adv.Name:='AdvForm';
       Adv.Position:=poScreenCenter;
       adv.BorderStyle:=bsDialog;
       adv.FormStyle:=fsStayOnTop;
       adv.Height:=120;
       adv.Width:=320;
       adv.BorderIcons:=[];
       adv.caption:='ariciao';
       adv.Visible:=true;
       lab:=TProgressBar.Create(nil);
       lab.Parent:=adv;
       lab.Top:=adv.Height div 2-20;
       lab.Left:=12;
       lab.Width:=adv.Width-30;
       lab.Visible:=true;
       lab.Max:=100;
       lab.min:=0;
       lab.Position:=0;
       FOR X := 0 TO MS.Size - 1 DO
             begin
                  MS.Read(C, 1);
                  Application.ProcessMessages;
                  O := C;
                  C := (C xor (Key shr 8));
                  Key := (O + Key) * C1 + C2;
                  SS.Write(C,1);
                  Application.ProcessMessages;
                  cur:=SS.Size;
                  lab.position:=Longint(Trunc( (cur * 100) / Tot ));
                  Application.ProcessMessages;
                  adv.caption:=extractfilename(infname)+' - '+inttostr(lab.position)+'%';
                  Application.ProcessMessages;
             end;
    FINALLY
           SS.Free;
           MS.Free;
           adv.free;
    end;
end;

end.
