unit IEInstVerConst;

{
  ------------------------------------------------------------------------------
  ------------------------------------------------------------------------------

  IEInstVer
  Copyright  2001, 2002 Ch. Bergmann
  All rights reserved.

  ------------------------------------------------------------------------------

  All contents of this file and all other files included in the IEInstVer
  archive are Copyright  2001, 2002 Ch. Bergmann - AS NOT OTHERWISE MARKED.

  Use and/or distribution of them requires acceptance of the following
  License Agreement.

  ------------------------------------------------------------------------------

  LICENSE AGREEMENT 1.2:

  "Author" herein refers Ch. Bergmann (the creator of the IEInstVer component).
  "Software" refers to all files bearing this notice, as well as any other
  files and source code included with IEInstVer (typically part of a .zip
  archive), and all content in them, regardless of whether any modifications
  have been made.

  1) This notice may not be removed or altered from any source distribution.

  2) The origin of this software must not be misrepresented, you must not
     claim that you wrote the original software.

  3) The Software may NOT be redistributed in ANY FORM (including but not
     limited to .DPK, .DCR, .PAS, .DCU) after you have obtained it (typically
     by downloading from the Authors site) without the express written
     permission of the Author.

  4) You are permitted to compile the Software into any kind of applications
     (Freeware, Shareware, Commercial).
     If you use this software in a product, an acknowledgment in the product
     documentation or the product itself would be appreciated but is not
     required.

  5) This software is provided "AS-IS", without any express or implied
     warranty. In no event shall the Author be held liable for any damages
     arising from the use of/inability to use this software.

  6) Full backward compatibility in future versions of the Software is not
     guaranteed. In no event shall the Author be held liable for any
     inconvenience or damages arising from lack of backward compatibility.

  7) The Author may terminate your rights to use the Software for any reason
     at his sole discretion.

  8) If you do not agree to any of these terms, you are not permitted to use
     the Software in any way, and all copies of it must be deleted from your
     system(s).

  ------------------------------------------------------------------------------
  ------------------------------------------------------------------------------
}

interface

const
  IEIVersion = '4.9';
  IEIDate = '2002/10/06';

  {
    -!--!--!--!--!--!--!--!--!--!--!--!--!--!--!--!--!--!--!--!--!--!--!--!--!-

     Microsoft, Windows, Office are registered trademarks of Microsoft Corp.
     Internet Explorer is trademark of Microsoft Corp.

     Microsoft Internet Explorer Version Information are
     Copyright  Microsoft Corp. and are mostly taken from:

     Q164539 - How to Determine Which Version of Internet Explorer is Installed
     http://support.microsoft.com/support/kb/articles/q164/5/39.asp
     or
     http://support.microsoft.com/default.aspx?scid=kb;EN-US;q164539

    -!--!--!--!--!--!--!--!--!--!--!--!--!--!--!--!--!--!--!--!--!--!--!--!--!-
  }

  MS = 'Microsoft ';
  MI = 'Internet Explorer ';
  MW = 'Windows ';
  MO = 'Office ';

  IE1_01 = MS + MI + '1.0 (' + MS + MW + '95 Plus! (eta))';

  IE2_01 = MS + MI + '2.0 (' + MS + MW + '95)';
  IE2_02 = MS + MI + '2.0 (' + MS + MW + 'NT)';

  IE3_00 = MS + MI + '3';
  IE3_01 = MS + MI + '3.0';
  IE3_02 = MS + MI + '3.0 (OSR 2)';
  IE3_03 = MS + MI + '3.01';
  IE3_04 = MS + MI + '3.02(a)';

  IE4_00 = MS + MI + '4';
  IE4_01 = MS + MI + '4.0 (Public Preview 2)';
  IE4_02 = MS + MI + '4.0';
  IE4_03 = MS + MI + '4.01';
  IE4_04 = MS + MI + '4.01 (SP 1)';
  IE4_05 = MS + MI + '4.01 (SP 2)';
  IE4_06 = MS + MI + '4.x ("Server-Side Page Reference Redirect" Issue Update Installed.)';

  IE5_00 = MS + MI + '5';
  IE5_01 = MS + MI + '5 Developer Preview (eta 1)';
  IE5_02 = MS + MI + '5 (eta/eta 2)';
  IE5_03 = MS + MI + '5';
  IE5_03a = MS + MI + '5 (' + MS + MW + '98)'; //-chb undocumented
  IE5_04 = MS + MI + '5 (' + MS + MO + '2000)';
  IE5_05 = MS + MI + '5.01 (' + MS + MW + '2000 (eta 3), Build 5.00.2031)';
  IE5_06 = MS + MI + '5 (' + MS + MW + '98 SE)';
  IE5_07 = MS + MI + '5 ("Malformed Favorites Icon" Security Issue Update Installed.)';
  IE5_08 = MS + MI + '5 ("ImportExport Favorites()" Security Issue Update Installed.)';
  IE5_09 = MS + MI + '5.0 ("Server-Side Page Reference Redirect" Issue Update Installed.)';
  IE5_10 = MS + MI + '5.01 (' + MS + MW + '2000 (RC 1), Build 5.00.2072)';
  IE5_11 = MS + MI + '5.01 (' + MS + MW + '2000 (RC 2), Build 5.00.2128)';
  IE5_12 = MS + MI + '5.01 (' + MS + MO + '2000 (SR-1))';
  IE5_13 = MS + MI + '5.01 ("Server-side Page Reference Redirect" Issue Update Installed.)';
  IE5_14 = MS + MI + '5.01 (' + MS + MW + '2000 (RC 3), Build 5.00.2183 (2195))'; //-chb (undocumented)
  IE5_15 = MS + MI + '5.01 (SP 1) (' + MS + MW + '2000)';
  IE5_16 = MS + MI + '5.01 (SP 1) (' + MS + MW + '95/98 or NT 4.0)';
  IE5_17 = MS + MI + '5.01 (SP 2) (' + MS + MW + '95/98 or NT 4.0)';
  IE5_18 = MS + MI + '5.01 (SP 2) (' + MS + MW + '2000)';

  IE55_00 = MS + MI + '5.5';
  IE55_01 = MS + MI + '5.5 (Developer Preview) (eta) (' + MS + MW + 'ME (eta 2), Build 4.90.2419)'; //-chb (undocumented)
  IE55_02 = MS + MI + '5.5 & Internet Tools (eta)';
  IE55_03 = MS + MI + '5.5 (' + MS + MW + 'ME, Build 4.90.3000)';
  IE55_04 = MS + MI + '5.5';
  IE55_05 = MS + MI + '5.5 Advanced Security Privacy (eta)';
  IE55_06 = MS + MI + '5.5 (SP 1)';
  IE55_07 = MS + MI + '5.5 (SP 2)';

  IE6_00 = MS + MI + '6';
  IE6_01 = MS + MI + '6 Public Preview (1) (eta)';
  IE6_0U1 = MS + MI + '6 (eta) (eta-Tester Only)'; //-chb undocumented
  IE6_02 = MS + MI + '6 Public Preview (2) (eta) Refresh';
  IE6_0U2 = MS + MI + '6 pre-RC1 (eta) (eta-Tester Only)'; //-chb undocumented
  IE6_0U3 = MS + MI + '6 post-RC1 (eta) (eta-Tester Only)'; //-chb undocumented
  IE6_0U4 = MS + MI + '6 post-RC2 (eta) (eta-Tester Only)'; //-chb undocumented
  IE6_03 = MS + MI + '6 (' + MS + MW + 'XP)';
  IE6_0U5 = MS + MI + '6 (SP 1) (eta 1) (eta-Tester Only)'; //-chb undocumented
  IE6_0U6 = MS + MI + '6 (SP 1) (eta 2) (eta-Tester Only)'; //-chb undocumented
  IE6_0U7 = MS + MI + '6 (SP 1) (eta 3) (eta-Tester Only)'; //-chb undocumented
  IE6_0U8 = MS + MI + '6 (SP 1) (eta 4) (eta-Tester Only)'; //-chb undocumented
  IE6_0U9 = MS + MI + '6 (SP 1) (eta 5) (eta-Tester Only)'; //-chb undocumented
  IE6_0U0 = MS + MI + '6 (SP 1) (eta-Tester Only)'; //-chb undocumented
  IE6_04 = MS + MI + '6 (SP 1) (' + MS + MW + 'XP SP 1)';

  IE6x_00 = MS + MI + '6.x';

  CRG = #67#111#112#121#114#105#103#104#116#32#169#32#50#48#48#49#44#32#50#48#48 +
    #50#32#32#67#104#46#32#66#101#114#103#109#97#110#110#46;
  ARR = #65#108#108#32#82#105#103#104#116#115#32#82#101#115#101#114#118#101#100#46;

implementation

end.
