unit IEInstVerReg;

{
  ------------------------------------------------------------------------------
  ------------------------------------------------------------------------------

  IEInstVer
  Copyright  2001, 2002 Ch. Bergmann
  All rights reserved.

  ------------------------------------------------------------------------------

  All contents of this file and all other files included in the IEInstVer
  archive are Copyright  2001, 2002 Ch. Bergmann - AS NOT OTHERWISE MARKED.

  Use and/or distribution of them requires acceptance of the following
  License Agreement.

  ------------------------------------------------------------------------------

  LICENSE AGREEMENT 1.2:

  "Author" herein refers Ch. Bergmann (the creator of the IEInstVer component).
  "Software" refers to all files bearing this notice, as well as any other
  files and source code included with IEInstVer (typically part of a .zip
  archive), and all content in them, regardless of whether any modifications
  have been made.

  1) This notice may not be removed or altered from any source distribution.

  2) The origin of this software must not be misrepresented, you must not
     claim that you wrote the original software.

  3) The Software may NOT be redistributed in ANY FORM (including but not
     limited to .DPK, .DCR, .PAS, .DCU) after you have obtained it (typically
     by downloading from the Authors site) without the express written
     permission of the Author.

  4) You are permitted to compile the Software into any kind of applications
     (Freeware, Shareware, Commercial).
     If you use this software in a product, an acknowledgment in the product
     documentation or the product itself would be appreciated but is not
     required.

  5) This software is provided "AS-IS", without any express or implied
     warranty. In no event shall the Author be held liable for any damages
     arising from the use of/inability to use this software.

  6) Full backward compatibility in future versions of the Software is not
     guaranteed. In no event shall the Author be held liable for any
     inconvenience or damages arising from lack of backward compatibility.

  7) The Author may terminate your rights to use the Software for any reason
     at his sole discretion.

  8) If you do not agree to any of these terms, you are not permitted to use
     the Software in any way, and all copies of it must be deleted from your
     system(s).

  ------------------------------------------------------------------------------
  ------------------------------------------------------------------------------
}

interface

uses
{$IFDEF VER100}DsgnIntf; {$ENDIF}{$IFDEF VER120}DsgnIntf; {$ENDIF}
{$IFDEF VER130}DsgnIntf; {$ENDIF}{$IFDEF VER140}DesignIntf, DesignEditors; {$ENDIF}
{$IFDEF VER150}DesignIntf, DesignEditors; {$ENDIF}

type
  TAboutPropertyEditor = class(TPropertyEditor)
  public
    function GetValue: string; override;
    function GetAttributes: TPropertyAttributes; override;
    procedure Edit; override;
  end;

  TAboutComponentEditor = class(TDefaultEditor)
  public
    function GetVerb(Index: Integer): string; override;
    function GetVerbCount: Integer; override;
    procedure ExecuteVerb(Index: Integer); override;
    procedure Edit; override;
  end;

procedure Register;

implementation

uses Classes, Dialogs, IEInstVer, IEInstVerL, IEInstVerConst;

const
  MSG = #73#69#73#110#115#116#86#101#114#32 + IEIVersion + #32#32#91 + IEIDate +
    #93#10#13#10#13 + CRG + #10#13 + ARR + #10#13#10#13#121#122#111#64#103#109 +
    #120#46#110#101#116#10#13#104#116#116#112#58#47#47#121#97#122#110#111#46#116 +
    #114#105#112#111#100#46#99#111#109#47#105#101#105#110#115#116#118#101#114#47;

function TAboutPropertyEditor.GetAttributes: TPropertyAttributes;
begin
  Result := [paDialog, paReadOnly]
end;

function TAboutPropertyEditor.GetValue: string;
begin
  Result := '|[ DoubleClick ]|'
end;

procedure TAboutPropertyEditor.Edit;
begin
  MessageDlg(MSG, mtInformation, [mbOK], 0)
end;

function TAboutComponentEditor.GetVerb(Index: Integer): AnsiString;
begin
  Result := '&About IEInstVer'
end;

function TAboutComponentEditor.GetVerbCount: Integer;
begin
  Result := 1
end;

procedure TAboutComponentEditor.ExecuteVerb(Index: Integer);
begin
  if not (Index = 0) then exit;
  edit
end;

procedure TAboutComponentEditor.Edit;
begin
  MessageDlg(MSG, mtInformation, [mbOK], 0)
end;

procedure Register;
begin
  RegisterComponents('yzoComps', [TIEInstVer, TIEInstVerL]);
  RegisterComponentEditor(TIEInstVer, TAboutComponentEditor);
  RegisterComponentEditor(TIEInstVerL, TAboutComponentEditor);
  RegisterPropertyEditor(TypeInfo(string), TIEInstVer, 'About', TAboutPropertyEditor);
  RegisterPropertyEditor(TypeInfo(string), TIEInstVerL, 'About', TAboutPropertyEditor)
end;

end.
