unit TestU;

interface

uses
  {$IfDef Linux}
  SysUtils, Classes, QGraphics, QControls, QForms, QDialogs,
  QStdCtrls, mwLexStates, QExtCtrls, QmwFastTime, Libc, Dialogs, StdCtrls,
  Controls, ExtCtrls, mwStringStream;
  {$EndIf}

  {$IfDef MSWindows}
  SysUtils, Classes, QGraphics, QControls, QForms, QDialogs,
  QStdCtrls, mwLexStates, QExtCtrls, QmwFastTime, mwStringStream;
  {$EndIf}
type
  TForm1 = class(TForm)
    OpenDialog1: TOpenDialog;
    Panel1: TPanel;
    Button1: TButton;
    Memo1: TMemo;
    Time1: TQmwFastTime;
    Button2: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

  {$R *.dfm}
  
procedure InitForAsm(Lex: TmwGenericLexer); forward;

procedure InitForPas(Lex: TmwGenericLexer);
var
  Identifiers: TmwIdentifiers;
  Pat, OptPat, Temp: TmwLexState;
  AsmSubLex: TmwGenericLexer;
begin
  AsmSubLex:= TmwGenericLexer.Create(Lex);
  AsmSubLex.InitProc := InitForAsm;

  { Zero }
  Pat:= CreateKey(Lex, #0, True, False, piZero, piZero);
  Pat.Min := 1;

  { Space}
  Pat:=CreateSet(Lex, [#1..#9, #11, #12, #14..#32], True, piSpace, piSpace);
  Pat.Min := 1;

  { LineEnd}
  CreateLineEnd(Lex, True);
  Pat.Min := 1;

  { String }
  Pat := CreateKey(Lex, '''', True, False, piBadString, piBadString);
  Pat.Min := 1;
  Pat := CreateTillKey(Pat, '''', False, False, piString, piString);
  Pat.Min := 1;
  Temp:= Pat;
  Pat := CreateKey(Pat, '''', False, False, piBadString, piBadString);
  Pat.Min := 1;
  Pat.ToRegress:= Temp;

  { String }
  Pat := CreateKey(Lex, '#', True, False, piString, piString);
  Pat := CreateSet(Pat, ['0'..'9'], False, piString, piString);
  Pat.Min := 1;
  OptPat := CreateKey(Pat, '$', True, False, piString, piString);
  OptPat.Min := 1;
  CreateSet(OptPat,['0'..'9', 'A'..'F', 'a'..'f'], False, piString, piString);

  { Comment }
  Pat := CreateKey(Lex,'{', True, False, piComment, piComment);
  Pat.Min:= 1;
  Pat := CreateTillKey(Pat,'}', False, False, piComment, piComment);
  Pat.MultiLine := True;

  { Symbol, Comment }
  Pat := CreateKey(Lex, '//', True, False, piComment, piComment);
  Pat.Min := 1;
  OptPat := CreateKey(Pat, '/', True, False, piSymbol, piSymbol);
  OptPat.Min := 1;
  CreateNotSet(Pat, [#10, #13], False, piComment, piComment);

  { Symbol, Comment }
  Pat := CreateKey(Lex, '(*', True, False, piComment, piComment);
  Pat.Min := 1;
  OptPat := CreateKey(Pat, '(.', True, False, piSymbol, piSymbol);
  OptPat.Min := 1;
  OptPat := CreateKey(Pat, '(', True, False, piSymbol, piSymbol);
  OptPat.Min := 1;
  Pat := CreateTillKey(Pat, '*)', False, False, piComment, piComment);
  Pat.MultiLine := True;


  { Number }
  Pat := CreateSet(Lex, ['0'..'9'], True, piNumber, piNumber);
  Pat := CreateKey(Pat, '.', False, False, piNumber, piNumber);
  Pat.Max := 1;
  Pat := CreateSet(Pat, ['0'..'9'], False, piNumber, piNumber);
  Pat.Max := 1;
  Pat := CreateSet(Pat, ['e', 'E'], False, piNumber, piNumber);
  Pat.Max := 1;
  Pat := CreateSet(Pat, ['+', '-'], False, piNumber, piNumber);
  CreateSet(Pat, ['0'..'9'], False, piNumber, piNumber);

  { Number }
  Pat := CreateKey(Lex, '$', True, False, piNumber, piNumber);
  Pat.Min := 1;
  CreateSet(Pat, ['0'..'9', 'A'..'F', 'a'..'f'], False, piNumber, piNumber);

  { Symbol }
  Pat := CreateKey(Lex, ':=', True, False, piSymbol, piSymbol);
  Pat.Min := 1;
  OptPat := CreateKey(Pat, ':', True, False, piSymbol, piSymbol);
  OptPat.Min := 1;

  { Symbol }
  Pat := CreateKey(Lex, '<=', True, False, piSymbol, piSymbol);
  Pat.Min := 1;
  OptPat := CreateKey(Pat, '<>', True, False, piSymbol, piSymbol);
  OptPat.Min := 1;
  OptPat := CreateKey(Pat, '<', True, False, piSymbol, piSymbol);
  OptPat.Min := 1;

  { Symbol }
  Pat := CreateKey(Lex, '>=', True, False, piSymbol, piSymbol);
  Pat.Min := 1;
  OptPat := CreateKey(Pat, '>', True, False, piSymbol, piSymbol);
  OptPat.Min := 1;

  { Symbol }
  Pat := CreateKey(Lex, '.)', True, False, piSymbol, piSymbol);
  Pat.Min := 1;
  OptPat := CreateKey(Pat, '.', True, False, piSymbol, piSymbol);
  OptPat.Min := 1;

  {Identifiers and KeyWords }
  Identifiers:= TmwIdentifiers.Create(Lex, True, ['_', 'A'..'Z', 'a'..'z'], ['_', '0'..'9', 'A'..'Z', 'a'..'z']);

  Identifiers.AddKey('array', True, piKeyWord, piKeyWord, nil, False);
  Identifiers.AddKey('and' , True, piKeyWord, piKeyWord, nil, False);
  Identifiers.AddKey('asm' , True, piKeyWord, piKeyWord, AsmSubLex, False);
  Identifiers.AddKey('as' , True, piKeyWord, piKeyWord, nil, False);
  Identifiers.AddKey('begin' , True, piKeyWord, piKeyWord, nil, False);
  Identifiers.AddKey('constructor' , True, piKeyWord, piKeyWord, nil, False);
  Identifiers.AddKey('class' , True, piKeyWord, piKeyWord, nil, False);
  Identifiers.AddKey('case' , True, piKeyWord, piKeyWord, nil, False);
  Identifiers.AddKey('const' , True, piKeyWord, piKeyWord, nil, False);
  Identifiers.AddKey('dispinterface' , True, piKeyWord, piKeyWord, nil, False);
  Identifiers.AddKey('destructor' , True, piKeyWord, piKeyWord, nil, False);
  Identifiers.AddKey('downto' , True, piKeyWord, piKeyWord, nil, False);
  Identifiers.AddKey('div' , True, piKeyWord, piKeyWord, nil, False);
  Identifiers.AddKey('do' , True, piKeyWord, piKeyWord, nil, False);
  Identifiers.AddKey('exports' , True, piKeyWord, piKeyWord, nil, False);
  Identifiers.AddKey('except' , True, piKeyWord, piKeyWord, nil, False);
  Identifiers.AddKey('else' , True, piKeyWord, piKeyWord, nil, False);
  Identifiers.AddKey('end' , True, piKeyWord, piKeyWord, nil, False);
  Identifiers.AddKey('finalization' , True, piKeyWord, piKeyWord, nil, False);
  Identifiers.AddKey('finally' , True, piKeyWord, piKeyWord, nil, False);
  Identifiers.AddKey('function' , True, piKeyWord, piKeyWord, nil, False);
  Identifiers.AddKey('file' , True, piKeyWord, piKeyWord, nil, False);
  Identifiers.AddKey('for' , True, piKeyWord, piKeyWord, nil, False);
  Identifiers.AddKey('goto' , True, piKeyWord, piKeyWord, nil, False);
  Identifiers.AddKey('implementation' , True, piKeyWord, piKeyWord, nil, False);
  Identifiers.AddKey('initialization' , True, piKeyWord, piKeyWord, nil, False);
  Identifiers.AddKey('inherited' , True, piKeyWord, piKeyWord, nil, False);
  Identifiers.AddKey('interface' , True, piKeyWord, piKeyWord, nil, False);
  Identifiers.AddKey('inline' , True, piKeyWord, piKeyWord, nil, False);
  Identifiers.AddKey('if' , True, piKeyWord, piKeyWord, nil, False);
  Identifiers.AddKey('in' , True, piKeyWord, piKeyWord, nil, False);
  Identifiers.AddKey('is' , True, piKeyWord, piKeyWord, nil, False);
  Identifiers.AddKey('library' , True, piKeyWord, piKeyWord, nil, False);
  Identifiers.AddKey('label' , True, piKeyWord, piKeyWord, nil, False);
  Identifiers.AddKey('mod' , True, piKeyWord, piKeyWord, nil, False);
  Identifiers.AddKey('nil' , True, piKeyWord, piKeyWord, nil, False);
  Identifiers.AddKey('not' , True, piKeyWord, piKeyWord, nil, False);
  Identifiers.AddKey('object' , True, piKeyWord, piKeyWord, nil, False);
  Identifiers.AddKey('out' , True, piKeyWord, piKeyWord, nil, False);
  Identifiers.AddKey('of' , True, piKeyWord, piKeyWord, nil, False);
  Identifiers.AddKey('or' , True, piKeyWord, piKeyWord, nil, False);
  Identifiers.AddKey('procedure' , True, piKeyWord, piKeyWord, nil, False);
  Identifiers.AddKey('property' , True, piKeyWord, piKeyWord, nil, False);
  Identifiers.AddKey('program' , True, piKeyWord, piKeyWord, nil, False);
  Identifiers.AddKey('packed' , True, piKeyWord, piKeyWord, nil, False);
  Identifiers.AddKey('resourcestring' , True, piKeyWord, piKeyWord, nil, False);
  Identifiers.AddKey('record' , True, piKeyWord, piKeyWord, nil, False);
  Identifiers.AddKey('repeat' , True, piKeyWord, piKeyWord, nil, False);
  Identifiers.AddKey('raise' , True, piKeyWord, piKeyWord, nil, False);
  Identifiers.AddKey('string' , True, piKeyWord, piKeyWord, nil, False);
  Identifiers.AddKey('set' , True, piKeyWord, piKeyWord, nil, False);
  Identifiers.AddKey('shl' , True, piKeyWord, piKeyWord, nil, False);
  Identifiers.AddKey('shr' , True, piKeyWord, piKeyWord, nil, False);
  Identifiers.AddKey('threadvar' , True, piKeyWord, piKeyWord, nil, False);
  Identifiers.AddKey('then' , True, piKeyWord, piKeyWord, nil, False);
  Identifiers.AddKey('try' , True, piKeyWord, piKeyWord, nil, False);
  Identifiers.AddKey('type' , True, piKeyWord, piKeyWord, nil, False);
  Identifiers.AddKey('to' , True, piKeyWord, piKeyWord, nil, False);
  Identifiers.AddKey('until' , True, piKeyWord, piKeyWord, nil, False);
  Identifiers.AddKey('unit' , True, piKeyWord, piKeyWord, nil, False);
  Identifiers.AddKey('uses' , True, piKeyWord, piKeyWord, nil, False);
  Identifiers.AddKey('var' , True, piKeyWord, piKeyWord, nil, False);
  Identifiers.AddKey('while' , True, piKeyWord, piKeyWord, nil, False);
  Identifiers.AddKey('with' , True, piKeyWord, piKeyWord, nil, False);
  Identifiers.AddKey('xor' , True, piKeyWord, piKeyWord, nil, False);
end;

procedure InitForAsm(Lex: TmwGenericLexer);
var
  Identifiers: TmwIdentifiers;
  Pat, OptPat, Temp: TmwLexState;
begin

  { Zero }
  CreateKey(Lex, #0, True, False, piZero, piZero);

  { Space}
  CreateSet(Lex, [#1..#9, #11, #12, #14..#32], True, piSpace, piSpace);

  { LineEnd}
  CreateLineEnd(Lex, True);

  { String }
  Pat := CreateKey(Lex, '''', True, False, piBadString, piBadString);
  Pat.Min := 1;
  Pat := CreateTillKey(Pat, '''', False, False, piString, piString);
  Pat.Min := 1;
  Temp:= Pat;
  Pat := CreateKey(Pat, '''', False, False, piBadString, piBadString);
  Pat.Min := 1;
  Pat.ToRegress:= Temp;

  { String }
  Pat := CreateKey(Lex, '#', True, False, piString, piString);
  Pat := CreateSet(Pat, ['0'..'9'], False, piString, piString);
  Pat.Min := 1;
  OptPat := CreateKey(Pat, '$', True, False, piString, piString);
  OptPat.Min := 1;
  CreateSet(OptPat,['0'..'9', 'A'..'F', 'a'..'f'], False, piString, piString);

  { Comment }
  Pat := CreateKey(Lex,'{', True, False, piComment, piComment);
  Pat := CreateTillKey(Pat,'}', False, False, piComment, piComment);
  Pat.MultiLine := True;

  { Symbol, Comment }
  Pat := CreateKey(Lex, '//', True, False, piComment, piComment);
  Pat.Min := 1;
  OptPat := CreateKey(Pat, '/', True, False, piSymbol, piSymbol);
  OptPat.Min := 1;
  CreateNotSet(Pat, [#10, #13], False, piComment, piComment);

  { Symbol, Comment }
  Pat := CreateKey(Lex, '(*', True, False, piComment, piComment);
  Pat.Min := 1;
  OptPat := CreateKey(Pat, '(.', True, False, piSymbol, piSymbol);
  OptPat.Min := 1;
  OptPat := CreateKey(Pat, '(', True, False, piSymbol, piSymbol);
  OptPat.Min := 1;
  Pat := CreateTillKey(Pat, '*)', False, False, piComment, piComment);
  Pat.MultiLine := True;


  { Number }
  Pat := CreateSet(Lex, ['0'..'9'], True, piNumber, piNumber);
  Pat := CreateKey(Pat, '.', False, False, piNumber, piNumber);
  Pat.Max := 1;
  Pat := CreateSet(Pat, ['0'..'9'], False, piNumber, piNumber);
  Pat.Max := 1;
  Pat := CreateSet(Pat, ['e', 'E'], False, piNumber, piNumber);
  Pat.Max := 1;
  Pat := CreateSet(Pat, ['+', '-'], False, piNumber, piNumber);
  CreateSet(Pat, ['0'..'9'], False, piNumber, piNumber);

  { Number }
  Pat := CreateKey(Lex, '$', True, False, piNumber, piNumber);
  Pat.Min := 1;
  CreateSet(Pat, ['0'..'9', 'A'..'F', 'a'..'f'], False, piNumber, piNumber);

  { Symbol }
  Pat := CreateKey(Lex, ':=', True, False, piSymbol, piSymbol);
  Pat.Min := 1;
  OptPat := CreateKey(Pat, ':', True, False, piSymbol, piSymbol);
  OptPat.Min := 1;

  { Symbol }
  Pat := CreateKey(Lex, '<=', True, False, piSymbol, piSymbol);
  Pat.Min := 1;
  OptPat := CreateKey(Pat, '<>', True, False, piSymbol, piSymbol);
  OptPat.Min := 1;
  OptPat := CreateKey(Pat, '<', True, False, piSymbol, piSymbol);
  OptPat.Min := 1;

  { Symbol }
  Pat := CreateKey(Lex, '>=', True, False, piSymbol, piSymbol);
  Pat.Min := 1;
  OptPat := CreateKey(Pat, '>', True, False, piSymbol, piSymbol);
  OptPat.Min := 1;

  { Symbol }
  Pat := CreateKey(Lex, '.)', True, False, piSymbol, piSymbol);
  Pat.Min := 1;
  OptPat := CreateKey(Pat, '.', True, False, piSymbol, piSymbol);
  OptPat.Min := 1;

  {Identifiers and KeyWords }
  Identifiers:= TmwIdentifiers.Create(Lex, True, ['_', 'A'..'Z', 'a'..'z'], ['_', '0'..'9', 'A'..'Z', 'a'..'z']);

  Identifiers.AddKey('PUSH' , True,  piAsmKeyWord, piAsmKeyWord, nil, False);
  Identifiers.AddKey('OR' , True,  piAsmKeyWord, piAsmKeyWord, nil, False);
  Identifiers.AddKey('POP' , True,  piAsmKeyWord, piAsmKeyWord, nil, False);
  Identifiers.AddKey('CALL' , True,  piAsmKeyWord, piAsmKeyWord, nil, False);
  Identifiers.AddKey('MOV' , True,  piAsmKeyWord, piAsmKeyWord, nil, False);
  Identifiers.AddKey('CMP' , True,  piAsmKeyWord, piAsmKeyWord, nil, False);
  Identifiers.AddKey('SUB' , True,  piAsmKeyWord, piAsmKeyWord, nil, False);
  Identifiers.AddKey('EBX' , True,  piAsmKeyWord, piAsmKeyWord, nil, False);
  Identifiers.AddKey('EDI' , True,  piAsmKeyWord, piAsmKeyWord, nil, False);
  Identifiers.AddKey('ESI' , True,  piAsmKeyWord, piAsmKeyWord, nil, False);
  Identifiers.AddKey('EDX' , True,  piAsmKeyWord, piAsmKeyWord, nil, False);
  Identifiers.AddKey('XCHG' , True,  piAsmKeyWord, piAsmKeyWord, nil, False);
  Identifiers.AddKey('EAX' , True,  piAsmKeyWord, piAsmKeyWord, nil, False);
  Identifiers.AddKey('EDX' , True,  piAsmKeyWord, piAsmKeyWord, nil, False);
  Identifiers.AddKey('LOCK' , True,  piAsmKeyWord, piAsmKeyWord, nil, False);
  Identifiers.AddKey('XADD' , True,  piAsmKeyWord, piAsmKeyWord, nil, False);
  Identifiers.AddKey('JA' , True,  piAsmKeyWord, piAsmKeyWord, nil, False);
  Identifiers.AddKey('DEC' , True,  piAsmKeyWord, piAsmKeyWord, nil, False);
  Identifiers.AddKey('ECX' , True,  piAsmKeyWord, piAsmKeyWord, nil, False);
  Identifiers.AddKey('Test' , True,  piAsmKeyWord, piAsmKeyWord, nil, False);
  Identifiers.AddKey('JE' , True,  piAsmKeyWord, piAsmKeyWord, nil, False);
  Identifiers.AddKey('RET' , True,  piAsmKeyWord, piAsmKeyWord, nil, False);
  Identifiers.AddKey('JMP' , True,  piAsmKeyWord, piAsmKeyWord, nil, False);
  Identifiers.AddKey('JNE' , True,  piAsmKeyWord, piAsmKeyWord, nil, False);
  Identifiers.AddKey('LEA' , True,  piAsmKeyWord, piAsmKeyWord, nil, False);
  Identifiers.AddKey('IMUL' , True,  piAsmKeyWord, piAsmKeyWord, nil, False);

  Identifiers.AddKey('end' , True, piKeyWord, piKeyWord, nil, True);
end;

function IdToStr(Id: Word): string;
begin
  case Id of
    High(Word): Result := 'piAtEnd';
    High(Word) - 1: Result := 'piZero';
    0: Result := 'piSymbol';
    1: Result := 'piSpace';
    2: Result := 'piLineEnd';
    3: Result := 'piInnerLineEnd';
    4: Result := 'piIdent';
    5: Result := 'piKeyWord';
    6: Result := 'piString';
    7: Result := 'piComment';
    8: Result := 'piNumber';
    9: Result := 'piAssembler';
    10: Result:= 'piBadString';
    11: Result:= 'piAsmKeyWord';
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  Lex: TmwGenericLexer;
  Stream: TMemoryStream;
begin
  if OpenDialog1.Execute then
  begin
    Lex := TmwGenericLexer.Create(nil);
    Lex.InitProc := InitForPas;
    Stream := TMemoryStream.Create;
    Stream.LoadFromFile(OpenDialog1.FileName);
    Lex.SetStartData(Stream.Memory, Stream.Size);
    Time1.Start;
    while not Lex.AtEnd do
    begin
      Lex.Next;
    end;
    Time1.Stop;
    Lex.Free;
    Stream.Free;
    Caption:= Time1.ElapsedTime;
  end;
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  I: Integer;
  S: String;
  Stream: TmwStringStream;
  Lex: TmwGenericLexer;
  List: TStringList;
begin
  if OpenDialog1.Execute then
  begin
    Stream:= TmwStringStream.Create;
    List:= TStringList.Create;
    Lex := TmwGenericLexer.Create(nil);
    Lex.InitProc := InitForPas;
    List.LoadFromFile(OpenDialog1.FileName);
    for I:= 0 to List.Count -1 do
    begin
      Lex.SetStartData(PChar(List[I]), Length(List[I]));
      while not Lex.AtEnd do Lex.Next;
      if I +1 < List.Count then
        List.Objects[I+1]:= Lex.Range;
    end;

    Memo1.Lines.BeginUpdate;
    Memo1.Lines.Clear;
    for I:= 0 to List.Count -1 do
    begin
      Lex.SetStartData(PChar(List[I]), Length(List[I]));
      Lex.Range:= TmwLexState(List.Objects[I]);
      while not Lex.AtEnd do
      begin
        Lex.Next;
      {$IfDef Linux}
        S:= Lex.Token + '    ' + IdToStr(Lex.Id) + #10;
      {$EndIf}
      {$IfDef MSWindows}
        S:= Lex.Token + '    ' + IdToStr(Lex.Id) + #13#10;
      {$EndIf}
        Stream.Write(Pchar(s)^, Length(s));
      end;
    end;
    Memo1.Lines.Text:= Stream.DataString;
    Memo1.Lines.EndUpdate;
    Stream.Free;
    Lex.Free;
    List.Free;
    Caption:= '';
  end;
end;
end.

