{*******************************************************}
{                     PHP4Delphi                        }
{               PHP - Delphi interface                  }
{                        v.2.2                          }
{ Author:                                               }
{ Serhiy Perevoznyk                                     }
{ serge_perevoznyk@hotmail.com                          }
{ http://users.chello.be/ws36637                        }
{*******************************************************}

{
You can download the latest version of PHP from
http://www.php.net/downloads.php
You have to download and install PHP separately.
It is not included in the package.

For more information on the PHP Group and the PHP project,
please see <http://www.php.net>.
The PHP Licence is available at through the world-wide-web at
http://www.php.net/license/2_02.txt.

This unit was tested with PHP 4.2.3
}

unit PHP4Delphi;

interface

uses
  Windows;

type

//register global variables BEFORE executing the PHP script
//Ex:
//RegisterVariables('var1=val1&variable2=value2&name=me);
//You have to add to your php.ini next line:
//register_globals = On

TRegisterVariables = procedure (VarString : PChar) ; stdcall;

TGetArray = function : PChar; stdcall;

var
 RegisterVariables : TRegisterVariables = nil;
 GetArray : TGetArray = nil;

//execute PHP script
//FileName - the name of the file with full path like c:\php\test.php
function RunPHPScript(FileName : string) : string;

//Execute PHP code from string
function RunPHPCode(ACode : string) : string;

function PHPLoaded : boolean;


implementation

type
 TExecutePHP = procedure (FileName : Pchar; ACallBack : pointer)  stdcall;

var
 DelphiPHPLib : THandle = 0;
 ExecutePHP : TExecutePHP = nil;
 PHPResult : string;
 ExecuteCode : TExecutePHP = nil;

procedure PHPCallBack(c: char); stdcall;
begin
 PHPResult := PHPResult + c;
end;

function PHPLoaded : boolean;
begin
  Result := DelphiPHPLib <> 0;
end;

procedure UnloadPHP;
begin
  if PHPLoaded then
   begin
      FreeLibrary(DelphiPHPLib);
      DelphiPHPLib := 0;
      @ExecutePHP := nil;
      @RegisterVariables := nil;
      @ExecuteCode := nil;
      @GetArray := nil;
   end;
end;

procedure LoadPHP;
const
  ExecutePHPName = 'ExecutePHP';
  RegisterVariablesName = 'RegisterVariables';
  ExecuteCodeName = 'ExecuteCode';
  GetArrayName = 'GetArray';

begin
  DelphiPHPLib := LoadLibrary('php4Delphi.dll');
  if PHPLoaded then
   begin
     @ExecutePHP := GetProcAddress(DelphiPHPLib,ExecutePHPName);
     @RegisterVariables := GetProcAddress(DelphiPHPLib,RegisterVariablesName);
     @GetArray := GetProcAddress(DelphiPHPLib,GetArrayName);
     @ExecuteCode :=  GetProcAddress(DelphiPHPLib,ExecuteCodeName);
     if ((not Assigned(ExecutePHP)) or (not Assigned(RegisterVariables) ) or
     (not Assigned(GetArray)) ) then
       UnloadPHP;
   end;
end;


function RunPHPScript(FileName : string) : string;
begin
  PHPResult := '';
  if PHPLoaded then
    ExecutePHP(PChar(FileName),@PHPCallback);
  Result := PHPResult;
end;

function RunPHPCode(ACode : string) : string;
begin
 PHPResult := '';
  if PHPLoaded then
    ExecuteCode(PChar(ACode),@PHPCallback);
  Result := PHPResult;
end;

initialization
 LoadPHP;
finalization
 UnloadPHP;
end.