{*******************************************************}
{                                                       }
{          psvLabels Delphi components Library          }
{                                                       }
{ Author:                                               }
{ Serhiy Perevoznyk                                     }
{ serge_perevoznyk@hotmail.com                          }
{                                                       }
{     Use, modification and distribution is allowed     }
{without limitation, warranty, or liability of any kind.}
{                                                       }
{*******************************************************}

unit psvLCDLabel;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;

type
  TpsvLCDLabel = class(TGraphicControl)
  private
    FBitmap  : TBitmap;
    FCaption : String;
    procedure SetCaption(const AValue : string);
  protected
   procedure SetName(const Value: TComponentName); override;

  public
    constructor Create(AOwner : TComponent); override;
    destructor  Destroy; override;
    procedure   Paint; override;
  published
    property Caption : string read FCaption write SetCaption;
  end;

implementation

{$R PSVFONT.res}

{ TpsvLCDLabel }

constructor TpsvLCDLabel.Create(AOwner: TComponent);
begin
  inherited;
  FBitmap := TBitmap.Create;
  FBitmap.Handle := LoadBitmap(hInstance,'PSVFONT');
  Width := 32;
  Height := 20;
  ControlStyle := ControlStyle + [csSetCaption];
end;

destructor TpsvLCDLabel.Destroy;
begin
  FBitmap.Free;
  inherited;
end;

procedure TpsvLCDLabel.Paint;
var I : integer;
    CH : char;
    k : integer;
    SrcRect, DstRect : TRect;
begin
  inherited;
  Width := 16*Length(FCaption);
  for i :=1 to Length(FCaption) do
   begin
     if FCaption[i] < ' ' then
      ch := ' ' else
       ch := FCaption[i];
     K := ord(ch) - 32;
     SrcRect := Rect(k*16 ,0, k*16 + 16,19);
     DstRect := Rect((i-1) * 16, 0, (i-1)*16 + 16 ,19);
     Canvas.CopyRect(DstRect, FBitmap.Canvas, SrcRect);
   end;
end;

procedure TpsvLCDLabel.SetCaption(const AValue: string);
begin
  if AValue <> FCaption then
   begin
    FCaption := UpperCase(AValue);
    Invalidate;
   end;
end;

procedure TpsvLCDLabel.SetName(const Value: TComponentName);
begin
  inherited;
  Caption := Value;
end;

end.
